## librime 0.9.4

=== CMakeLists.txt ===
set(CMAKE_USER_MAKE_RULES_OVERRIDE ${CMAKE_CURRENT_SOURCE_DIR}/cmake/c_flag_overrides.cmake)
set(CMAKE_USER_MAKE_RULES_OVERRIDE_CXX ${CMAKE_CURRENT_SOURCE_DIR}/cmake/cxx_flag_overrides.cmake)

project(rime)
cmake_minimum_required(VERSION 2.8)

set(LIBRIME_VERSION 0.9.4)
set(LIBRIME_SOVERSION 0)

option(BUILD_STATIC "Build static version of Rime" OFF)
option(BUILD_DATA "Build data for Rime" OFF)

SET(RIME_DATA_DIR "/share/rime-data" CACHE STRING "Target directory for Rime data")

if(WIN32)
  set(EXT ".exe")
endif(WIN32)

set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

set(Boost_USE_STATIC_LIBS ${BUILD_STATIC})
set(Gflags_STATIC ${BUILD_STATIC})
set(Glog_STATIC ${BUILD_STATIC})
set(KyotoCabinet_STATIC ${BUILD_STATIC})
set(Opencc_STATIC ${BUILD_STATIC})
set(YamlCpp_STATIC ${BUILD_STATIC})

set(Boost_USE_MULTITHREADED ON)
if(MSVC)
  set(Boost_USE_STATIC_RUNTIME ON)
endif(MSVC)
find_package(Boost 1.46.0 REQUIRED COMPONENTS filesystem regex signals system thread)
if(Boost_FOUND)
  include_directories(${Boost_INCLUDE_DIRS})
  link_directories(${Boost_LIBRARY_DIRS})
endif(Boost_FOUND)

find_package(Gflags)
if(Gflags_FOUND)
  include_directories(${Gflags_INCLUDE_PATH})
endif(Gflags_FOUND)

find_package(Glog REQUIRED)
if(Glog_FOUND)
  include_directories(${Glog_INCLUDE_PATH})
endif(Glog_FOUND)

find_package(Threads)
find_package(GTest)
if(GTEST_FOUND)
  include_directories(${GTEST_INCLUDE_DIRS})
endif(GTEST_FOUND)

find_package(YamlCpp REQUIRED)
if(YamlCpp_FOUND)
  include_directories(${YamlCpp_INCLUDE_PATH})
endif(YamlCpp_FOUND)

find_package(ZLIB)
find_package(KyotoCabinet REQUIRED)
if(KyotoCabinet_FOUND)
  include_directories(${KyotoCabinet_INCLUDE_PATH})
endif(KyotoCabinet_FOUND)

find_package(Opencc REQUIRED)
if(Opencc_FOUND)
  include_directories(${Opencc_INCLUDE_PATH})
endif(Opencc_FOUND)

find_path(X11Keysym X11/keysym.h)
if(X11Keysym)
  message(STATUS "Found X11/keysym.h at ${X11Keysym}")
  include_directories(${X11Keysym})
else(X11Keysym)
  message(WARNING "X11/keysym.h not found.")
endif(X11Keysym)

include_directories(${PROJECT_SOURCE_DIR}/include)
include_directories(${PROJECT_SOURCE_DIR}/thirdparty/include)
link_directories(${PROJECT_SOURCE_DIR}/thirdparty/lib)
if(MSVC)
  include_directories(${PROJECT_SOURCE_DIR}/thirdparty/include/msvc)
  add_definitions("/wd4244 /wd4996")
endif(MSVC)

if(NOT DEFINED LIB_INSTALL_DIR)
    set(LIB_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/lib)
endif()

if(NOT DEFINED BIN_INSTALL_DIR)
    set(BIN_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/bin)
endif()

if(NOT BUILD_STATIC)
  # uninstall target
  configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)
  add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
  set(prefix "${CMAKE_INSTALL_PREFIX}")
  set(exec_prefix "${CMAKE_INSTALL_PREFIX}")
  set(bindir "${exec_prefix}/bin")
  set(libdir "${LIB_INSTALL_DIR}")
  set(pkgdatadir "${prefix}${RIME_DATA_DIR}")
  set(includedir "${CMAKE_INSTALL_PREFIX}/include")
  configure_file(${PROJECT_SOURCE_DIR}/rime.pc.in ${PROJECT_BINARY_DIR}/rime.pc)
  install(FILES include/rime_api.h DESTINATION include)
  install(FILES ${PROJECT_BINARY_DIR}/rime.pc DESTINATION ${LIB_INSTALL_DIR}/pkgconfig)
  install(FILES cmake/RimeConfig.cmake DESTINATION share/cmake/rime)
  if(BUILD_DATA)
    install(FILES ${PROJECT_SOURCE_DIR}/data/default.yaml DESTINATION ${pkgdatadir})
    install(FILES ${PROJECT_SOURCE_DIR}/data/essay.kct DESTINATION ${pkgdatadir})
    file(GLOB preset_schema ${PROJECT_SOURCE_DIR}/data/preset/*.yaml)
    install(FILES ${preset_schema} DESTINATION ${pkgdatadir})
    file(GLOB supplement_schema ${PROJECT_SOURCE_DIR}/data/supplement/*.yaml)
    install(FILES ${supplement_schema} DESTINATION ${pkgdatadir})
  endif(BUILD_DATA)
endif(NOT BUILD_STATIC)

add_subdirectory(src)
add_subdirectory(tools)
if(GTEST_FOUND)
  add_subdirectory(test)
endif(GTEST_FOUND)

=== Makefile ===
sharedir = $(DESTDIR)/usr/share
bindir = $(DESTDIR)/usr/bin

all: librime
	@echo ':)'

install: install-librime
	@echo ':)'

uninstall: uninstall-librime
	@echo ':)'

librime-static:
	mkdir -p build-static
	(cd build-static; cmake -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_BUILD_TYPE=Release -DBUILD_STATIC=ON ..)
	make -C build-static

librime:
	mkdir -p build
	(cd build; cmake -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_BUILD_TYPE=Release ..)
	make -C build

install-librime:
	make -C build install

uninstall-librime:
	make -C build uninstall

debug:
	mkdir -p debug-build
	(cd debug-build; cmake -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_BUILD_TYPE=Debug ..)
	make -C debug-build

debug-install:
	make -C debug-build install

debug-uninstall:
	make -C debug-build uninstall

=== src/CMakeLists.txt ===
set(LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR}/lib)

aux_source_directory(. LIBRIME_SRC_BASE)
aux_source_directory(algo LIBRIME_SRC_ALGO)
aux_source_directory(dict LIBRIME_SRC_DICT)
aux_source_directory(gear LIBRIME_SRC_GEAR)
aux_source_directory(lever LIBRIME_SRC_LEVER)

set(LIBRIME_SRC ${LIBRIME_SRC_BASE} ${LIBRIME_SRC_ALGO} ${LIBRIME_SRC_DICT} ${LIBRIME_SRC_GEAR} ${LIBRIME_SRC_LEVER})

set(RIME_OPTIONAL_DEPS "")
if(Gflags_FOUND)
  set(RIME_OPTIONAL_DEPS ${RIME_OPTIONAL_DEPS} ${Gflags_LIBRARY})
endif(Gflags_FOUND)

set(RIME_DEPS 
    ${Boost_LIBRARIES} ${Glog_LIBRARY} ${YamlCpp_LIBRARY} ${KyotoCabinet_LIBRARY} ${Opencc_LIBRARY}
    ${ZLIB_LIBRARY} ${CMAKE_THREAD_LIBS_INIT} ${RIME_OPTIONAL_DEPS})

if(BUILD_STATIC)
  add_library(rime-static STATIC ${LIBRIME_SRC})
  target_link_libraries(rime-static ${RIME_DEPS})
  set_target_properties(rime-static PROPERTIES OUTPUT_NAME "rime" PREFIX "lib")
else(BUILD_STATIC)
  add_library(rime SHARED ${LIBRIME_SRC})
  target_link_libraries(rime ${RIME_DEPS})
  set_target_properties(rime PROPERTIES DEFINE_SYMBOL "RIME_EXPORTS")
  set_target_properties(rime PROPERTIES VERSION ${LIBRIME_VERSION} SOVERSION ${LIBRIME_SOVERSION})
  if(XCODE_VERSION)
    set_target_properties(rime PROPERTIES INSTALL_NAME_DIR "@rpath")
  endif(XCODE_VERSION)
  install(TARGETS rime DESTINATION ${LIB_INSTALL_DIR})
endif(BUILD_STATIC)

=== test/CMakeLists.txt ===
if(BUILD_STATIC)
  set(RIME_LIBRARY rime-static)
else(BUILD_STATIC)
  set(RIME_LIBRARY rime)
endif(BUILD_STATIC)

aux_source_directory(. RIME_TEST_SRC)
set(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/test)
add_executable(rime_test ${RIME_TEST_SRC})
target_link_libraries(rime_test
                      ${RIME_LIBRARY}
                      ${GTEST_LIBRARIES})
add_dependencies(rime_test ${RIME_LIBRARY})

file(COPY ${PROJECT_SOURCE_DIR}/data/test/config_test.yaml 
     DESTINATION ${EXECUTABLE_OUTPUT_PATH})
file(COPY ${PROJECT_SOURCE_DIR}/data/test/dictionary_test.yaml 
     DESTINATION ${EXECUTABLE_OUTPUT_PATH})

if(NOT MSVC AND NOT XCODE_VERSION)
set(RIME_TEST_EXECUTABLE ${EXECUTABLE_OUTPUT_PATH}/rime_test${EXT})
add_custom_command(TARGET rime_test
                   POST_BUILD
                   COMMAND ${RIME_TEST_EXECUTABLE}
                   WORKING_DIRECTORY ${EXECUTABLE_OUTPUT_PATH})
endif(NOT MSVC AND NOT XCODE_VERSION)

=== tools/CMakeLists.txt ===
set(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin)

if(BUILD_STATIC)
  set(RIME_LIBRARY rime-static)
else(BUILD_STATIC)
  set(RIME_LIBRARY rime)
endif(BUILD_STATIC)

set(RIME_API_CONSOLE_SRC "rime_api_console.cc")
add_executable(rime_api_console ${RIME_API_CONSOLE_SRC})
target_link_libraries(rime_api_console ${RIME_LIBRARY})
add_dependencies(rime_api_console ${RIME_LIBRARY})

set(RIME_CONSOLE_SRC "rime_console.cc")
add_executable(rime_console ${RIME_CONSOLE_SRC})
target_link_libraries(rime_console ${RIME_LIBRARY})
add_dependencies(rime_console ${RIME_LIBRARY})

set(RIME_DICT_MANAGER_SRC "rime_dict_manager.cc")
add_executable(rime_dict_manager ${RIME_DICT_MANAGER_SRC})
target_link_libraries(rime_dict_manager ${RIME_LIBRARY})
add_dependencies(rime_dict_manager ${RIME_LIBRARY})

set(RIME_DEPLOYER_SRC "rime_deployer.cc")
add_executable(rime_deployer ${RIME_DEPLOYER_SRC})
target_link_libraries(rime_deployer ${RIME_LIBRARY})
add_dependencies(rime_deployer ${RIME_LIBRARY})

install(TARGETS rime_dict_manager DESTINATION ${BIN_INSTALL_DIR})
install(TARGETS rime_deployer DESTINATION ${BIN_INSTALL_DIR})

file(COPY ${PROJECT_SOURCE_DIR}/data/minimal/default.yaml 
     DESTINATION ${EXECUTABLE_OUTPUT_PATH})
file(COPY ${PROJECT_SOURCE_DIR}/data/minimal/essay.kct
     DESTINATION ${EXECUTABLE_OUTPUT_PATH})
file(COPY ${PROJECT_SOURCE_DIR}/data/minimal/luna_pinyin.dict.yaml 
     DESTINATION ${EXECUTABLE_OUTPUT_PATH})
file(COPY ${PROJECT_SOURCE_DIR}/data/minimal/luna_pinyin.schema.yaml
     DESTINATION ${EXECUTABLE_OUTPUT_PATH})
file(COPY ${PROJECT_SOURCE_DIR}/data/minimal/cangjie5.dict.yaml
     DESTINATION ${EXECUTABLE_OUTPUT_PATH})
file(COPY ${PROJECT_SOURCE_DIR}/data/minimal/cangjie5.schema.yaml
     DESTINATION ${EXECUTABLE_OUTPUT_PATH})

=== debian/changelog ===
librime (0.9.4-1) unstable; urgency=low

  * New upstream release.
  * Delete patches.
  * Add --fail-missing to rules.

 -- Qijiang Fan <fqj1994@gmail.com>  Wed, 26 Sep 2012 21:51:49 +0800

librime (0.9.2+git20120725-1) unstable; urgency=low

  * Initial release (Closes: #677341).

 -- Qijiang Fan <fqj1994@gmail.com>  Fri, 08 Jun 2012 18:04:26 +0800

=== debian/control ===
Source: librime
Section: libs
Priority: extra
Maintainer: IME Packaging Team <pkg-ime-devel@lists.alioth.debian.org>
Uploaders: Qijiang Fan <fqj1994@gmail.com>, Aron Xu <aron@debian.org>
Build-Depends: debhelper (>= 9), libkyotocabinet-dev, libyaml-cpp-dev, cmake, libopencc-dev, zlib1g-dev, x11proto-core-dev, libboost-dev, libboost-filesystem-dev, libboost-regex-dev, libboost-signals-dev, libboost-system-dev, libboost-thread-dev, libgoogle-glog-dev
Standards-Version: 3.9.3
Homepage: http://code.google.com/p/rimeime
Vcs-Git: git://git.debian.org/git/pkg-ime/librime.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ime/librime.git;a=summary


Package: librime0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: librime-bin, librime-data
Description: Rime Input Method Engine - core library
 RIME is the acronym of Rime Input Method Engine.
 .
 RIME is a lightweight, extensible input method engine supporting various input
 schematas including glyph-based input methods, romanization-based input methods
 as well as those for Chinese dialects. It has the ability to compose phrases
 and sentences intelligently and provide very accurate traditional Chinese
 output. RIME's cross-platform core library is written in C++, and can work
 consistently on different platforms with OS-specific wrappers.
 .
 This package provides the core library of RIME.
 
Package: librime-bin
Architecture: any
Section: utils
Depends: librime0 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Rime Input Method Engine - utilities
 RIME is the acronym of Rime Input Method Engine.
 .
 RIME is a lightweight, extensible input method engine supporting various input
 schematas including glyph-based input methods, romanization-based input methods
 as well as those for Chinese dialects. It has the ability to compose phrases
 and sentences intelligently and provide very accurate traditional Chinese
 output. RIME's cross-platform core library is written in C++, and can work
 consistently on different platforms with OS-specific wrappers.
 .
 This package provides the executable utilities of RIME. 

Package: librime-dev
Architecture: all
Section: libdevel
Depends: librime0 (>= ${source:Version}), librime0 (<< ${source:Version}+1~), ${misc:Depends}
Description: Rime Input Method Engine, the core library - development files
 RIME is the acronym of Rime Input Method Engine.
 .
 RIME is a lightweight, extensible input method engine supporting various input
 schematas including glyph-based input methods, romanization-based input methods
 as well as those for Chinese dialects. It has the ability to compose phrases
 and sentences intelligently and provide very accurate traditional Chinese
 output. RIME's cross-platform core library is written in C++, and can work
 consistently on different platforms with OS-specific wrappers.
 .
 This package provides the development files of RIME.

Package: librime0-dbg
Architecture: any
Section: debug
Depends: librime0 (= ${binary:Version}), ${misc:Depends}
Description: Rime Input Method Engine, the core library - debugging symbols
 RIME is the acronym of Rime Input Method Engine.
 .
 RIME is a lightweight, extensible input method engine supporting various input
 schematas including glyph-based input methods, romanization-based input methods
 as well as those for Chinese dialects. It has the ability to compose phrases
 and sentences intelligently and provide very accurate traditional Chinese
 output. RIME's cross-platform core library is written in C++, and can work
 consistently on different platforms with OS-specific wrappers.
 .
 This package provides the debugging symbols of RIME.

=== debian/watch ===
version=3
http://githubredir.debian.net/githubredir.cgi?author=lotem&project=librime /github/lotem/librime/rime-([0-9\.]*)\.tar\.gz

## librime 0.9.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,10 +4,11 @@
 project(rime)
 cmake_minimum_required(VERSION 2.8)
 
-set(LIBRIME_VERSION 0.9.4)
+set(LIBRIME_VERSION 0.9.8)
 set(LIBRIME_SOVERSION 0)
 
-option(BUILD_STATIC "Build static version of Rime" OFF)
+option(BUILD_SHARED_LIBS "Build Rime as shared library" ON)
+option(BUILD_STATIC "Build Rime using static libraries" OFF)
 option(BUILD_DATA "Build data for Rime" OFF)
 
 SET(RIME_DATA_DIR "/share/rime-data" CACHE STRING "Target directory for Rime data")

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,10 @@
+RIME_ROOT = $(CURDIR)
+THIRDPARTY_PATHS = -DCMAKE_INCLUDE_PATH=$(RIME_ROOT)/thirdparty/include -DCMAKE_LIBRARY_PATH=$(RIME_ROOT)/thirdparty/lib
+
 sharedir = $(DESTDIR)/usr/share
 bindir = $(DESTDIR)/usr/bin
+
+.PHONY: all install uninstall thirdparty clean librime-static librime debug
 
 all: librime
 	@echo ':)'
@@ -10,9 +15,15 @@
 uninstall: uninstall-librime
 	@echo ':)'
 
+thirdparty:
+	make -f Makefile.thirdparty
+
+clean:
+	rm -Rf build build-static debug-build
+
 librime-static:
 	mkdir -p build-static
-	(cd build-static; cmake -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_BUILD_TYPE=Release -DBUILD_STATIC=ON ..)
+	(cd build-static; cmake -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_BUILD_TYPE=Release -DBUILD_STATIC=ON -DBUILD_SHARED_LIBS=OFF $(THIRDPARTY_PATHS) ..)
 	make -C build-static
 
 librime:
@@ -31,8 +42,8 @@
 	(cd debug-build; cmake -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_BUILD_TYPE=Debug ..)
 	make -C debug-build
 
-debug-install:
+install-debug:
 	make -C debug-build install
 
-debug-uninstall:
+uninstall-debug:
 	make -C debug-build uninstall

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -13,16 +13,16 @@
   set(RIME_OPTIONAL_DEPS ${RIME_OPTIONAL_DEPS} ${Gflags_LIBRARY})
 endif(Gflags_FOUND)
 
-set(RIME_DEPS 
+set(RIME_DEPS
     ${Boost_LIBRARIES} ${Glog_LIBRARY} ${YamlCpp_LIBRARY} ${KyotoCabinet_LIBRARY} ${Opencc_LIBRARY}
     ${ZLIB_LIBRARY} ${CMAKE_THREAD_LIBS_INIT} ${RIME_OPTIONAL_DEPS})
 
-if(BUILD_STATIC)
+if(NOT BUILD_SHARED_LIBS)
   add_library(rime-static STATIC ${LIBRIME_SRC})
   target_link_libraries(rime-static ${RIME_DEPS})
   set_target_properties(rime-static PROPERTIES OUTPUT_NAME "rime" PREFIX "lib")
-else(BUILD_STATIC)
-  add_library(rime SHARED ${LIBRIME_SRC})
+else(NOT BUILD_SHARED_LIBS)
+  add_library(rime ${LIBRIME_SRC})
   target_link_libraries(rime ${RIME_DEPS})
   set_target_properties(rime PROPERTIES DEFINE_SYMBOL "RIME_EXPORTS")
   set_target_properties(rime PROPERTIES VERSION ${LIBRIME_VERSION} SOVERSION ${LIBRIME_SOVERSION})
@@ -30,4 +30,4 @@
     set_target_properties(rime PROPERTIES INSTALL_NAME_DIR "@rpath")
   endif(XCODE_VERSION)
   install(TARGETS rime DESTINATION ${LIB_INSTALL_DIR})
-endif(BUILD_STATIC)
+endif(NOT BUILD_SHARED_LIBS)

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,8 @@
-if(BUILD_STATIC)
+if(BUILD_SHARED_LIBS)
+  set(RIME_LIBRARY rime)
+else(BUILD_SHARED_LIBS)
   set(RIME_LIBRARY rime-static)
-else(BUILD_STATIC)
-  set(RIME_LIBRARY rime)
-endif(BUILD_STATIC)
+endif(BUILD_SHARED_LIBS)
 
 aux_source_directory(. RIME_TEST_SRC)
 set(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/test)
@@ -12,9 +12,9 @@
                       ${GTEST_LIBRARIES})
 add_dependencies(rime_test ${RIME_LIBRARY})
 
-file(COPY ${PROJECT_SOURCE_DIR}/data/test/config_test.yaml 
+file(COPY ${PROJECT_SOURCE_DIR}/data/test/config_test.yaml
      DESTINATION ${EXECUTABLE_OUTPUT_PATH})
-file(COPY ${PROJECT_SOURCE_DIR}/data/test/dictionary_test.yaml 
+file(COPY ${PROJECT_SOURCE_DIR}/data/test/dictionary_test.yaml
      DESTINATION ${EXECUTABLE_OUTPUT_PATH})
 
 if(NOT MSVC AND NOT XCODE_VERSION)

=== tools/CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,10 @@
 set(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin)
 
-if(BUILD_STATIC)
+if(BUILD_SHARED_LIBS)
+  set(RIME_LIBRARY rime)
+else(BUILD_SHARED_LIBS)
   set(RIME_LIBRARY rime-static)
-else(BUILD_STATIC)
-  set(RIME_LIBRARY rime)
-endif(BUILD_STATIC)
+endif(BUILD_SHARED_LIBS)
 
 set(RIME_API_CONSOLE_SRC "rime_api_console.cc")
 add_executable(rime_api_console ${RIME_API_CONSOLE_SRC})
@@ -29,11 +29,11 @@
 install(TARGETS rime_dict_manager DESTINATION ${BIN_INSTALL_DIR})
 install(TARGETS rime_deployer DESTINATION ${BIN_INSTALL_DIR})
 
-file(COPY ${PROJECT_SOURCE_DIR}/data/minimal/default.yaml 
+file(COPY ${PROJECT_SOURCE_DIR}/data/minimal/default.yaml
      DESTINATION ${EXECUTABLE_OUTPUT_PATH})
 file(COPY ${PROJECT_SOURCE_DIR}/data/minimal/essay.kct
      DESTINATION ${EXECUTABLE_OUTPUT_PATH})
-file(COPY ${PROJECT_SOURCE_DIR}/data/minimal/luna_pinyin.dict.yaml 
+file(COPY ${PROJECT_SOURCE_DIR}/data/minimal/luna_pinyin.dict.yaml
      DESTINATION ${EXECUTABLE_OUTPUT_PATH})
 file(COPY ${PROJECT_SOURCE_DIR}/data/minimal/luna_pinyin.schema.yaml
      DESTINATION ${EXECUTABLE_OUTPUT_PATH})

=== debian/changelog ===
librime (0.9.8-1ubuntu1) raring; urgency=low

  * Disable the libime0 symbols file, which includes template symbols
    pulled in from insighttoolkit, boost and libstdc++ not belonging
    to the library ABI. Filed Debian bug #705902 for a real fix.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 22 Apr 2013 00:55:21 +0200

librime (0.9.8-1) unstable; urgency=low

  * New uptream release.
  * Add myself to Uploaders.

 -- YunQiang Su <wzssyqa@gmail.com>  Thu, 07 Feb 2013 16:25:20 +0800

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: libs
 Priority: extra
 Maintainer: IME Packaging Team <pkg-ime-devel@lists.alioth.debian.org>
-Uploaders: Qijiang Fan <fqj1994@gmail.com>, Aron Xu <aron@debian.org>
+Uploaders: Qijiang Fan <fqj1994@gmail.com>, Aron Xu <aron@debian.org>, YunQiang Su <wzssyqa@gmail.com>
 Build-Depends: debhelper (>= 9), libkyotocabinet-dev, libyaml-cpp-dev, cmake, libopencc-dev, zlib1g-dev, x11proto-core-dev, libboost-dev, libboost-filesystem-dev, libboost-regex-dev, libboost-signals-dev, libboost-system-dev, libboost-thread-dev, libgoogle-glog-dev
 Standards-Version: 3.9.3
 Homepage: http://code.google.com/p/rimeime

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ -- -Scmake

override_dh_strip:
	dh_strip --dbg-package=librime0-dbg

override_dh_install:
	dh_install --fail-missing

## librime 0.9.9

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 project(rime)
 cmake_minimum_required(VERSION 2.8)
 
-set(LIBRIME_VERSION 0.9.8)
+set(LIBRIME_VERSION 0.9.9)
 set(LIBRIME_SOVERSION 0)
 
 option(BUILD_SHARED_LIBS "Build Rime as shared library" ON)
@@ -92,7 +92,7 @@
     set(BIN_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/bin)
 endif()
 
-if(NOT BUILD_STATIC)
+if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
   # uninstall target
   configure_file(
     "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
@@ -112,13 +112,14 @@
   install(FILES cmake/RimeConfig.cmake DESTINATION share/cmake/rime)
   if(BUILD_DATA)
     install(FILES ${PROJECT_SOURCE_DIR}/data/default.yaml DESTINATION ${pkgdatadir})
+    install(FILES ${PROJECT_SOURCE_DIR}/data/symbols.yaml DESTINATION ${pkgdatadir})
     install(FILES ${PROJECT_SOURCE_DIR}/data/essay.kct DESTINATION ${pkgdatadir})
     file(GLOB preset_schema ${PROJECT_SOURCE_DIR}/data/preset/*.yaml)
     install(FILES ${preset_schema} DESTINATION ${pkgdatadir})
     file(GLOB supplement_schema ${PROJECT_SOURCE_DIR}/data/supplement/*.yaml)
     install(FILES ${supplement_schema} DESTINATION ${pkgdatadir})
   endif(BUILD_DATA)
-endif(NOT BUILD_STATIC)
+endif(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
 
 add_subdirectory(src)
 add_subdirectory(tools)

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 RIME_ROOT = $(CURDIR)
-THIRDPARTY_PATHS = -DCMAKE_INCLUDE_PATH=$(RIME_ROOT)/thirdparty/include -DCMAKE_LIBRARY_PATH=$(RIME_ROOT)/thirdparty/lib
+THIRDPARTY_PATHS = -DCMAKE_INCLUDE_PATH="$(RIME_ROOT)/thirdparty/include" -DCMAKE_LIBRARY_PATH="$(RIME_ROOT)/thirdparty/lib"
 
 sharedir = $(DESTDIR)/usr/share
 bindir = $(DESTDIR)/usr/bin

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -21,6 +21,7 @@
   add_library(rime-static STATIC ${LIBRIME_SRC})
   target_link_libraries(rime-static ${RIME_DEPS})
   set_target_properties(rime-static PROPERTIES OUTPUT_NAME "rime" PREFIX "lib")
+  install(TARGETS rime-static DESTINATION ${LIB_INSTALL_DIR})
 else(NOT BUILD_SHARED_LIBS)
   add_library(rime ${LIBRIME_SRC})
   target_link_libraries(rime ${RIME_DEPS})

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -14,7 +14,7 @@
 
 file(COPY ${PROJECT_SOURCE_DIR}/data/test/config_test.yaml
      DESTINATION ${EXECUTABLE_OUTPUT_PATH})
-file(COPY ${PROJECT_SOURCE_DIR}/data/test/dictionary_test.yaml
+file(COPY ${PROJECT_SOURCE_DIR}/data/test/dictionary_test.dict.yaml
      DESTINATION ${EXECUTABLE_OUTPUT_PATH})
 
 if(NOT MSVC AND NOT XCODE_VERSION)

=== tools/CMakeLists.txt ===
--- 
+++ 
@@ -31,6 +31,8 @@
 
 file(COPY ${PROJECT_SOURCE_DIR}/data/minimal/default.yaml
      DESTINATION ${EXECUTABLE_OUTPUT_PATH})
+file(COPY ${PROJECT_SOURCE_DIR}/data/minimal/symbols.yaml
+     DESTINATION ${EXECUTABLE_OUTPUT_PATH})
 file(COPY ${PROJECT_SOURCE_DIR}/data/minimal/essay.kct
      DESTINATION ${EXECUTABLE_OUTPUT_PATH})
 file(COPY ${PROJECT_SOURCE_DIR}/data/minimal/luna_pinyin.dict.yaml

=== debian/changelog ===
librime (0.9.9-1build1) trusty; urgency=low

  * No change rebuild against Boost 1.54.

 -- Dmitrijs Ledkovs <xnox@ubuntu.com>  Tue, 29 Oct 2013 15:58:34 +0000

librime (0.9.9-1) unstable; urgency=low

  * Imported Upstream version 0.9.9 (Closes: #724153)
  * Bump standard version to 3.9.4, no changes required.
  * Add a clean symbols file back:
     Only Rime* are symbols to export (Closes: #705902)
     Remove unused no-symbols-control-file
  * Update git url to canonical

 -- YunQiang Su <wzssyqa@gmail.com>  Fri, 11 Oct 2013 12:11:56 +0800

librime (0.9.8-2) unstable; urgency=low

  * Drop symbols file, as this package seems some chaos for symbols
    (Closes: #700988).
  * -DCMAKE_BUILD_TYPE=Release to disable lots logs (Closes: #702259).

 -- YunQiang Su <wzssyqa@gmail.com>  Wed, 20 Feb 2013 23:58:11 +0800

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: librime
 Section: libs
 Priority: extra
-Maintainer: IME Packaging Team <pkg-ime-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: IME Packaging Team <pkg-ime-devel@lists.alioth.debian.org>
 Uploaders: Qijiang Fan <fqj1994@gmail.com>, Aron Xu <aron@debian.org>, YunQiang Su <wzssyqa@gmail.com>
 Build-Depends: debhelper (>= 9), libkyotocabinet-dev, libyaml-cpp-dev, cmake, libopencc-dev, zlib1g-dev, x11proto-core-dev, libboost-dev, libboost-filesystem-dev, libboost-regex-dev, libboost-signals-dev, libboost-system-dev, libboost-thread-dev, libgoogle-glog-dev
-Standards-Version: 3.9.3
+Standards-Version: 3.9.4
 Homepage: http://code.google.com/p/rimeime
-Vcs-Git: git://git.debian.org/git/pkg-ime/librime.git
+Vcs-Git: git://anonscm.debian.org/pkg-ime/librime.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ime/librime.git;a=summary

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_make:
	dh_auto_configure -Scmake -- -DCMAKE_BUILD_TYPE=Release

override_dh_strip:
	dh_strip --dbg-package=librime0-dbg

override_dh_install:
	dh_install --fail-missing

=== debian/watch ===
version=3
https://github.com/lotem/librime/tags .*/rime-(\d[\d\.]+)\.tar\.gz

## librime 1.2+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,12 +4,16 @@
 project(rime)
 cmake_minimum_required(VERSION 2.8)
 
-set(LIBRIME_VERSION 0.9.9)
-set(LIBRIME_SOVERSION 0)
+set(LIBRIME_VERSION 1.2.0)
+set(LIBRIME_SOVERSION 1)
 
 option(BUILD_SHARED_LIBS "Build Rime as shared library" ON)
 option(BUILD_STATIC "Build Rime using static libraries" OFF)
 option(BUILD_DATA "Build data for Rime" OFF)
+option(BUILD_TEST "Build and run tests" OFF)
+option(BUILD_SEPARATE_LIBS "Build a separate rime-gears library" OFF)
+option(ENABLE_LOGGING "Enable logging with google-glog library" ON)
+option(BOOST_USE_CXX11 "Boost has been built with C++11 support" OFF)
 
 SET(RIME_DATA_DIR "/share/rime-data" CACHE STRING "Target directory for Rime data")
 
@@ -17,12 +21,14 @@
   set(EXT ".exe")
 endif(WIN32)
 
-set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)
+set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${PROJECT_SOURCE_DIR}/cmake")
+set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} "${PROJECT_SOURCE_DIR}/thirdparty")
 
 set(Boost_USE_STATIC_LIBS ${BUILD_STATIC})
 set(Gflags_STATIC ${BUILD_STATIC})
 set(Glog_STATIC ${BUILD_STATIC})
 set(KyotoCabinet_STATIC ${BUILD_STATIC})
+set(Marisa_STATIC ${BUILD_STATIC})
 set(Opencc_STATIC ${BUILD_STATIC})
 set(YamlCpp_STATIC ${BUILD_STATIC})
 
@@ -30,11 +36,13 @@
 if(MSVC)
   set(Boost_USE_STATIC_RUNTIME ON)
 endif(MSVC)
-find_package(Boost 1.46.0 REQUIRED COMPONENTS filesystem regex signals system thread)
+find_package(Boost 1.46.0 REQUIRED COMPONENTS filesystem regex signals system)
 if(Boost_FOUND)
   include_directories(${Boost_INCLUDE_DIRS})
   link_directories(${Boost_LIBRARY_DIRS})
 endif(Boost_FOUND)
+
+if(ENABLE_LOGGING)
 
 find_package(Gflags)
 if(Gflags_FOUND)
@@ -46,11 +54,19 @@
   include_directories(${Glog_INCLUDE_PATH})
 endif(Glog_FOUND)
 
+add_definitions(-DRIME_ENABLE_LOGGING)
+
+endif(ENABLE_LOGGING)
+
 find_package(Threads)
-find_package(GTest)
+
+if(BUILD_TEST)
+  find_package(GTest REQUIRED)
 if(GTEST_FOUND)
+  enable_testing()
   include_directories(${GTEST_INCLUDE_DIRS})
 endif(GTEST_FOUND)
+endif(BUILD_TEST)
 
 find_package(YamlCpp REQUIRED)
 if(YamlCpp_FOUND)
@@ -62,6 +78,11 @@
 if(KyotoCabinet_FOUND)
   include_directories(${KyotoCabinet_INCLUDE_PATH})
 endif(KyotoCabinet_FOUND)
+
+find_package(Marisa REQUIRED)
+if(Marisa_FOUND)
+  include_directories(${Marisa_INCLUDE_PATH})
+endif(Marisa_FOUND)
 
 find_package(Opencc REQUIRED)
 if(Opencc_FOUND)
@@ -80,9 +101,18 @@
 include_directories(${PROJECT_SOURCE_DIR}/thirdparty/include)
 link_directories(${PROJECT_SOURCE_DIR}/thirdparty/lib)
 if(MSVC)
-  include_directories(${PROJECT_SOURCE_DIR}/thirdparty/include/msvc)
+  if(MSVC10)
+    # stdint.h is missing from VS2010
+    include_directories(${PROJECT_SOURCE_DIR}/thirdparty/include/msvc)
+  endif(MSVC10)
   add_definitions("/wd4244 /wd4996")
 endif(MSVC)
+if(UNIX)
+  add_definitions("-std=c++11")
+endif(UNIX)
+if(NOT BOOST_USE_CXX11)
+  add_definitions("-DBOOST_NO_CXX11_SCOPED_ENUMS")
+endif()
 
 if(NOT DEFINED LIB_INSTALL_DIR)
     set(LIB_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/lib)
@@ -113,7 +143,7 @@
   if(BUILD_DATA)
     install(FILES ${PROJECT_SOURCE_DIR}/data/default.yaml DESTINATION ${pkgdatadir})
     install(FILES ${PROJECT_SOURCE_DIR}/data/symbols.yaml DESTINATION ${pkgdatadir})
-    install(FILES ${PROJECT_SOURCE_DIR}/data/essay.kct DESTINATION ${pkgdatadir})
+    install(FILES ${PROJECT_SOURCE_DIR}/data/essay.txt DESTINATION ${pkgdatadir})
     file(GLOB preset_schema ${PROJECT_SOURCE_DIR}/data/preset/*.yaml)
     install(FILES ${preset_schema} DESTINATION ${pkgdatadir})
     file(GLOB supplement_schema ${PROJECT_SOURCE_DIR}/data/supplement/*.yaml)
@@ -121,6 +151,19 @@
   endif(BUILD_DATA)
 endif(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
 
+if(BUILD_SHARED_LIBS)
+  add_definitions(-DRIME_BUILD_SHARED_LIBS)
+  set(RIME_LIBRARY rime)
+  if(BUILD_SEPARATE_LIBS)
+    set(RIME_GEARS_LIBRARY rime-gears)
+  endif(BUILD_SEPARATE_LIBS)
+else(BUILD_SHARED_LIBS)
+  set(RIME_LIBRARY rime-static)
+  if(BUILD_SEPARATE_LIBS)
+    set(RIME_GEARS_LIBRARY rime-gears-static)
+  endif(BUILD_SEPARATE_LIBS)
+endif(BUILD_SHARED_LIBS)
+
 add_subdirectory(src)
 add_subdirectory(tools)
 if(GTEST_FOUND)

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,4 @@
 RIME_ROOT = $(CURDIR)
-THIRDPARTY_PATHS = -DCMAKE_INCLUDE_PATH="$(RIME_ROOT)/thirdparty/include" -DCMAKE_LIBRARY_PATH="$(RIME_ROOT)/thirdparty/lib"
 
 sharedir = $(DESTDIR)/usr/share
 bindir = $(DESTDIR)/usr/bin
@@ -23,7 +22,7 @@
 
 librime-static:
 	mkdir -p build-static
-	(cd build-static; cmake -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_BUILD_TYPE=Release -DBUILD_STATIC=ON -DBUILD_SHARED_LIBS=OFF $(THIRDPARTY_PATHS) ..)
+	(cd build-static; cmake -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_BUILD_TYPE=Release -DBUILD_STATIC=ON -DBUILD_SHARED_LIBS=OFF ..)
 	make -C build-static
 
 librime:
@@ -39,7 +38,7 @@
 
 debug:
 	mkdir -p debug-build
-	(cd debug-build; cmake -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_BUILD_TYPE=Debug ..)
+	(cd debug-build; cmake -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_BUILD_TYPE=Debug -DBUILD_TEST=ON ..)
 	make -C debug-build
 
 install-debug:

=== src/CMakeLists.txt ===
set(LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR}/lib)

aux_source_directory(. LIBRIME_SRC_BASE)
aux_source_directory(algo LIBRIME_SRC_ALGO)
aux_source_directory(dict LIBRIME_SRC_DICT)
aux_source_directory(gear LIBRIME_SRC_GEAR)
aux_source_directory(lever LIBRIME_SRC_LEVER)

if(BUILD_SEPARATE_LIBS)
  set(LIBRIME_SRC ${LIBRIME_SRC_BASE})
  set(LIBRIME_GEARS_SRC ${LIBRIME_SRC_ALGO} ${LIBRIME_SRC_DICT} ${LIBRIME_SRC_GEAR} ${LIBRIME_SRC_LEVER})
else(BUILD_SEPARATE_LIBS)
  set(LIBRIME_SRC ${LIBRIME_SRC_BASE} ${LIBRIME_SRC_ALGO} ${LIBRIME_SRC_DICT} ${LIBRIME_SRC_GEAR} ${LIBRIME_SRC_LEVER})
endif(BUILD_SEPARATE_LIBS)

set(RIME_OPTIONAL_DEPS "")
if(Gflags_FOUND)
  set(RIME_OPTIONAL_DEPS ${RIME_OPTIONAL_DEPS} ${Gflags_LIBRARY})
endif(Gflags_FOUND)

set(RIME_CORE_DEPS ${Boost_LIBRARIES} ${Glog_LIBRARY} ${YamlCpp_LIBRARY} ${CMAKE_THREAD_LIBS_INIT} ${RIME_OPTIONAL_DEPS})
set(RIME_EXTRA_DEPS ${KyotoCabinet_LIBRARY} ${Marisa_LIBRARY} ${Opencc_LIBRARY} ${ZLIB_LIBRARY})

if(BUILD_SEPARATE_LIBS)
  set(RIME_DEPS ${RIME_CORE_DEPS})
  set(RIME_GEARS_DEPS ${RIME_LIBRARY} ${RIME_EXTRA_DEPS})
else(BUILD_SEPARATE_LIBS)
  set(RIME_DEPS ${RIME_CORE_DEPS} ${RIME_EXTRA_DEPS})
endif(BUILD_SEPARATE_LIBS)

if(BUILD_SHARED_LIBS)
  add_library(rime ${LIBRIME_SRC})
  target_link_libraries(rime ${RIME_DEPS})
  set_target_properties(rime PROPERTIES DEFINE_SYMBOL "RIME_EXPORTS")
  set_target_properties(rime PROPERTIES VERSION ${LIBRIME_VERSION} SOVERSION ${LIBRIME_SOVERSION})
  if(XCODE_VERSION)
    set_target_properties(rime PROPERTIES INSTALL_NAME_DIR "@rpath")
  endif(XCODE_VERSION)
  install(TARGETS rime DESTINATION ${LIB_INSTALL_DIR})
  if(BUILD_SEPARATE_LIBS)
    add_library(rime-gears ${LIBRIME_GEARS_SRC})
    target_link_libraries(rime-gears ${RIME_GEARS_DEPS})
    add_dependencies(rime-gears ${RIME_LIBRARY})
    set_target_properties(rime-gears PROPERTIES VERSION ${LIBRIME_VERSION} SOVERSION ${LIBRIME_SOVERSION})
    if(XCODE_VERSION)
      set_target_properties(rime-gears PROPERTIES INSTALL_NAME_DIR "@rpath")
    endif(XCODE_VERSION)
    install(TARGETS rime-gears DESTINATION ${LIB_INSTALL_DIR})
  endif(BUILD_SEPARATE_LIBS)
else(BUILD_SHARED_LIBS)
  add_library(rime-static STATIC ${LIBRIME_SRC})
  target_link_libraries(rime-static ${RIME_DEPS})
  set_target_properties(rime-static PROPERTIES OUTPUT_NAME "rime" PREFIX "lib")
  install(TARGETS rime-static DESTINATION ${LIB_INSTALL_DIR})
  if(BUILD_SEPARATE_LIBS)
    add_library(rime-gears-static STATIC ${LIBRIME_GEARS_SRC})
    target_link_libraries(rime-gears-static ${RIME_GEARS_DEPS})
    add_dependencies(rime-gears-static ${RIME_LIBRARY})
    set_target_properties(rime-gears-static PROPERTIES OUTPUT_NAME "rime-gears" PREFIX "lib")
    install(TARGETS rime-gears-static DESTINATION ${LIB_INSTALL_DIR})
  endif(BUILD_SEPARATE_LIBS)
endif(BUILD_SHARED_LIBS)

=== test/CMakeLists.txt ===
if(NOT (MSVC AND BUILD_SHARED_LIBS))

aux_source_directory(. RIME_TEST_SRC)
set(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/test)
add_executable(rime_test ${RIME_TEST_SRC})
target_link_libraries(rime_test
                      ${RIME_LIBRARY} ${RIME_GEARS_LIBRARY}
                      ${GTEST_LIBRARIES})
add_dependencies(rime_test ${RIME_LIBRARY} ${RIME_GEARS_LIBRARY})

file(COPY ${PROJECT_SOURCE_DIR}/data/test/config_test.yaml
     DESTINATION ${EXECUTABLE_OUTPUT_PATH})
file(COPY ${PROJECT_SOURCE_DIR}/data/test/dictionary_test.dict.yaml
     DESTINATION ${EXECUTABLE_OUTPUT_PATH})

set(RIME_TEST_EXECUTABLE ${EXECUTABLE_OUTPUT_PATH}/rime_test${EXT})
add_test(rime_test ${RIME_TEST_EXECUTABLE})

endif(NOT (MSVC AND BUILD_SHARED_LIBS))

=== thirdparty/src/marisa-trie/bindings/Makefile ===
ALL: swig-perl swig-python swig-ruby

swig-perl:
	swig -Wall -c++ -perl -outdir perl marisa-swig.i
	mv marisa-swig_wrap.cxx perl
	cp marisa-swig.cxx marisa-swig.h perl

swig-python:
	swig -Wall -c++ -python -outdir python marisa-swig.i
	mv marisa-swig_wrap.cxx python
	cp marisa-swig.cxx marisa-swig.h python

swig-ruby:
	swig -Wall -c++ -ruby -outdir ruby marisa-swig.i
	mv marisa-swig_wrap.cxx ruby
	cp marisa-swig.cxx marisa-swig.h ruby

=== thirdparty/src/opencc/data/CMakeLists.txt ===
set(
	OPENCC_DICT_BIN
	${CMAKE_BINARY_DIR}/src/tools/opencc_dict
)

add_custom_target(
	ocds
	ALL
	DEPENDS
		simp_to_trad_characters.ocd
		simp_to_trad_phrases.ocd
		trad_to_simp_characters.ocd
		trad_to_simp_phrases.ocd
)

foreach(DICT_PREFIX simp_to_trad trad_to_simp)

	foreach(DICT_SURFIX characters phrases)

		set (DICT ${DICT_PREFIX}_${DICT_SURFIX})

		add_custom_command(
			OUTPUT
				${DICT}.ocd
			COMMENT
				"Building ${DICT}.ocd"
			COMMAND
				${OPENCC_DICT_BIN} -i ${CMAKE_SOURCE_DIR}/data/${DICT_PREFIX}/${DICT_SURFIX}.txt -o ${DICT}.ocd
			DEPENDS opencc_dict
		)

		install(
			FILES
				${CMAKE_BINARY_DIR}/data/${DICT}.ocd
			DESTINATION
				${DIR_SHARE_OPENCC}
		)

		set_directory_properties(
			PROPERTIES
				ADDITIONAL_MAKE_CLEAN_FILES
					"${CMAKE_BINARY_DIR}/data/${DICT}.ocd"
		)

	endforeach(DICT_SURFIX)
endforeach(DICT_PREFIX)

set(CONFIG_FILES
	config/zhs2zht.ini
	config/zht2zhs.ini
	config/mix2zht.ini
	config/mix2zhs.ini
	config/zhs2zhtw_p.ini
	config/zhs2zhtw_v.ini
	config/zhs2zhtw_vp.ini
	config/zht2zhtw_p.ini
	config/zht2zhtw_v.ini
	config/zht2zhtw_vp.ini
	config/zhtw2zht.ini
	config/zhtw2zhs.ini
	config/zhtw2zhcn_s.ini
	config/zhtw2zhcn_t.ini
)

install(
	FILES
		${CONFIG_FILES}
	DESTINATION
		${DIR_SHARE_OPENCC}
)

set(TAIWAN_DICT_FILES
	tw/to_tw_variants.txt
	tw/to_tw_phrases.txt
	tw/from_tw_variants.txt
	tw/from_tw_phrases.txt
)

install(
	FILES
		${TAIWAN_DICT_FILES}
	DESTINATION
		${DIR_SHARE_OPENCC}
)

set(CHINA_DICT_FILES
	cn/to_cn_phrases.txt
)

install(
	FILES
		${CHINA_DICT_FILES}
	DESTINATION
		${DIR_SHARE_OPENCC}
)

if (BUILD_TESTING)
	foreach (DICT ${TAIWAN_DICT_FILES} ${CHINA_DICT_FILES})
		configure_file(${DICT} ${PROJECT_BINARY_DIR}/data COPYONLY)
	endforeach (DICT)
endif (BUILD_TESTING)

=== thirdparty/src/yaml-cpp/util/CMakeLists.txt ===
add_executable(parse parse.cpp)
target_link_libraries(parse yaml-cpp)

add_executable(sandbox sandbox.cpp)
target_link_libraries(sandbox yaml-cpp)

=== debian/changelog ===
librime (1.2+dfsg-2build2) wily; urgency=medium

  * No-change rebuild using GCC 5.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 28 Aug 2015 10:54:29 +0000

librime (1.2+dfsg-2build1) wily; urgency=medium

  * No-change rebuild against libgoogle-glog0v5

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 06 Aug 2015 20:16:35 +0000

librime (1.2+dfsg-2) unstable; urgency=medium

  * Rebuild with libyaml-cpp0.5, 0.5.2. (Closes: #784199)
  * Updated copyright.
  * Bumped standard version to 3.9.6, no changes needed.

 -- Guo Yixuan (郭溢譞) <culu.gyx@gmail.com>  Fri, 08 May 2015 01:14:42 -0400

librime (1.2+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Build-dep on libmarisa-dev.
  * Added oldschool.diff to build without c++11. (Closes: #754199)
  * Updated copyright.

 -- Guo Yixuan (郭溢譞) <culu.gyx@gmail.com>  Sat, 19 Jul 2014 12:54:07 -0400

librime (1.1+dfsg-2) unstable; urgency=medium

  * debian/watch: mangle version for repacking.
  * debian/copyright: added Files-Excluded to remove binaries.
  * debian/control: added myself to uploaders.
  * Renamed librime1-dev back to librime-dev, as advised by the
    release team.

 -- Guo Yixuan (郭溢譞) <culu.gyx@gmail.com>  Wed, 02 Jul 2014 21:42:55 -0400

librime (1.1+dfsg-1) unstable; urgency=medium

  [ Guo Yixuan (郭溢譞) ]
  * New upstream release. (Closes: #746152)
  * librime1-dev: conflicts and replaces librime-dev, for
    renaming.
  * librime1-dev: dropped max version dependency on librime1.
    (Closes: #750623)
  * Bumped standard version to 3.9.5, no changes needed.

  [ Osamu Aoki (青木 修) ]
  * Removed binary blobs in thirdparty/{bin,src/opencc-windows}/ .
  * Updated copyright file.
  * Re-add max version dependency using Upstream-Version.

 -- Osamu Aoki <osamu@debian.org>  Sun, 29 Jun 2014 21:54:11 +0900

librime (1.0-1~exp1) experimental; urgency=low

  * New upstream release.
  * Bumped SOVERSION.

 -- Aron Xu <aron@debian.org>  Tue, 03 Dec 2013 02:58:47 +0800

=== debian/control ===
--- 
+++ 
@@ -1,19 +1,36 @@
 Source: librime
 Section: libs
-Priority: extra
+Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: IME Packaging Team <pkg-ime-devel@lists.alioth.debian.org>
-Uploaders: Qijiang Fan <fqj1994@gmail.com>, Aron Xu <aron@debian.org>, YunQiang Su <wzssyqa@gmail.com>
-Build-Depends: debhelper (>= 9), libkyotocabinet-dev, libyaml-cpp-dev, cmake, libopencc-dev, zlib1g-dev, x11proto-core-dev, libboost-dev, libboost-filesystem-dev, libboost-regex-dev, libboost-signals-dev, libboost-system-dev, libboost-thread-dev, libgoogle-glog-dev
-Standards-Version: 3.9.4
+Uploaders: Qijiang Fan <fqj1994@gmail.com>,
+           Aron Xu <aron@debian.org>,
+           YunQiang Su <wzssyqa@gmail.com>,
+           Osamu Aoki <osamu@debian.org>,
+           Guo Yixuan (郭溢譞) <culu.gyx@gmail.com>
+Build-Depends: cmake,
+               debhelper (>= 9),
+               libboost-dev,
+               libboost-filesystem-dev,
+               libboost-regex-dev,
+               libboost-signals-dev,
+               libboost-system-dev,
+               libboost-thread-dev,
+               libgoogle-glog-dev,
+               libkyotocabinet-dev,
+               libmarisa-dev,
+               libopencc-dev,
+               libyaml-cpp-dev,
+               x11proto-core-dev,
+               zlib1g-dev
+Standards-Version: 3.9.6
 Homepage: http://code.google.com/p/rimeime
 Vcs-Git: git://anonscm.debian.org/pkg-ime/librime.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ime/librime.git;a=summary
 
-
-Package: librime0
+Package: librime1
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Recommends: librime-bin, librime-data
 Description: Rime Input Method Engine - core library
  RIME is the acronym of Rime Input Method Engine.
@@ -26,11 +43,11 @@
  consistently on different platforms with OS-specific wrappers.
  .
  This package provides the core library of RIME.
- 
+
 Package: librime-bin
 Architecture: any
-Section: utils
-Depends: librime0 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
+Depends: librime1 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Recommends: librime-data
 Description: Rime Input Method Engine - utilities
  RIME is the acronym of Rime Input Method Engine.
  .
@@ -41,12 +58,18 @@
  output. RIME's cross-platform core library is written in C++, and can work
  consistently on different platforms with OS-specific wrappers.
  .
- This package provides the executable utilities of RIME. 
+ This package provides the executable utilities of RIME.
+Section: utils
 
 Package: librime-dev
 Architecture: all
 Section: libdevel
-Depends: librime0 (>= ${source:Version}), librime0 (<< ${source:Version}+1~), ${misc:Depends}
+Depends: librime1 (<< ${source:Upstream-Version}.0~),
+         librime1 (>= ${source:Version}),
+         ${misc:Depends}
+Provides: librime1-dev
+Conflicts: librime1-dev
+Replaces: librime1-dev
 Description: Rime Input Method Engine, the core library - development files
  RIME is the acronym of Rime Input Method Engine.
  .
@@ -59,10 +82,11 @@
  .
  This package provides the development files of RIME.
 
-Package: librime0-dbg
+Package: librime1-dbg
 Architecture: any
 Section: debug
-Depends: librime0 (= ${binary:Version}), ${misc:Depends}
+Priority: extra
+Depends: librime1 (= ${binary:Version}), ${misc:Depends}
 Description: Rime Input Method Engine, the core library - debugging symbols
  RIME is the acronym of Rime Input Method Engine.
  .

=== debian/rules ===
#!/usr/bin/make -f

# See dpkg-buildflags(1)
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --parallel --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -Scmake -- -DCMAKE_BUILD_TYPE=Release

override_dh_strip:
	dh_strip --dbg-package=librime1-dbg

override_dh_install:
	dh_install --fail-missing

## librime 1.2.9+dfsg1

=== debian/changelog ===
librime (1.2.9+dfsg1-1) unstable; urgency=medium

  * Imported Upstream version 1.2.9+dfsg1
    (Closes: #793255, #811637, #822122)
  * Bump opencc to >= 1.0.1
  * std-ver: 3.9.6 -> 3.9.8, no change
  * Update homepage to Github
  * Update VCS-Browser URL to HTTPS
  * Add -DBOOST_USE_CXX11=ON
  * Remove unneeded patch
  * Replace libkyotocabinet-dev with libleveldb-dev
  * Remove unneeded docs installation

 -- Aron Xu <aron@debian.org>  Mon, 08 Aug 2016 17:30:01 +0800

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: librime
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: IME Packaging Team <pkg-ime-devel@lists.alioth.debian.org>
+Maintainer: IME Packaging Team <pkg-ime-devel@lists.alioth.debian.org>
 Uploaders: Qijiang Fan <fqj1994@gmail.com>,
            Aron Xu <aron@debian.org>,
            YunQiang Su <wzssyqa@gmail.com>,
@@ -17,16 +16,16 @@
                libboost-system-dev,
                libboost-thread-dev,
                libgoogle-glog-dev,
-               libkyotocabinet-dev,
+               libleveldb-dev,
                libmarisa-dev,
-               libopencc-dev,
+               libopencc-dev (>= 1.0.1),
                libyaml-cpp-dev,
                x11proto-core-dev,
                zlib1g-dev
-Standards-Version: 3.9.6
-Homepage: http://code.google.com/p/rimeime
+Standards-Version: 3.9.8
+Homepage: https://github.com/rime/librime
 Vcs-Git: git://anonscm.debian.org/pkg-ime/librime.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ime/librime.git;a=summary
+Vcs-Browser: https://anonscm.debian.org/gitweb/?p=pkg-ime/librime.git;a=summary
 
 Package: librime1
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

# See dpkg-buildflags(1)
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --parallel --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -Scmake -- -DCMAKE_BUILD_TYPE=Release -DBOOST_USE_CXX11=ON

override_dh_strip:
	dh_strip --dbg-package=librime1-dbg

override_dh_install:
	dh_install --fail-missing
